Subject: bug#52446: closed (Re: bug#52446: 28.0.90; Infinite loop in add_row_entry)

From: [email-masked] (GNU bug Tracking System)
Date: Mon, 13 Dec 2021 13:37:02 +0000

Your bug report

#52446: 28.0.90; Infinite loop in add_row_entry

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
52446: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=52446
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#52446: 28.0.90; Infinite loop in add_row_entry
From: Po Lu <[email-masked]>
To: Eli Zaretskii <[email-masked]>
Cc: [email-masked]
Date: Mon, 13 Dec 2021 21:35:46 +0800
List-Id: <debbugs-submit.debbugs.gnu.org>

Po Lu <[email-masked]> writes:

> Eli Zaretskii <[email-masked]> writes:
>
>> Now I'm confused: if row_table[i] is NULL for each i, then how did we
>> enter that loop?  Its condition checks for entry being non-NULL.
>
> The disassembly checks out, so that condition is not being mis-compiled.
> But that doesn't rule out the possibility of a miscompilation elsewhere.
>
> I will try to reproduce this under a memory checker, and with
> optimizations turned off.

It is a miscompilation of scrolling_window, which disappeared after
updating GCC.  Closing this bug, and thanks for the help.

Subject: 28.0.90; Infinite loop in add_row_entry
From: Po Lu <[email-masked]>
To: [email-masked]
Date: Sun, 12 Dec 2021 13:15:29 +0800
List-Id: <debbugs-submit.debbugs.gnu.org>

Emacs froze while I was scrolling through a large image with `C-n'.  The
source of the freeze was an infinite loop in this part of
`add_row_entry':

    while (entry && !row_equal_p (entry->row, row, 1))
--->  entry = entry->next;

The problem seems to be that `entry' points to the same address as
`entry->next'.